#version 300 es
precision highp float;
precision highp int;

uniform vec4 u_WorldSpaceCameraPos;
uniform float u_DirLightsEnabled[3];
uniform float u_DirLightNum;
uniform vec4 u_DirLightsDirection[3];
uniform vec4 u_DirLightsColor[3];
uniform float u_DirLightsIntensity[3];
uniform float u_PointLightsEnabled[2];
uniform float u_PointLightNum;
uniform vec4 u_PointLightsPosition[2];
uniform vec4 u_PointLightsColor[2];
uniform float u_PointLightsIntensity[2];
uniform float u_PointLightsAttenRangeInv[2];
uniform float u_SpotLightsEnabled[2];
uniform float u_SpotLightNum;
uniform vec4 u_SpotLightsPosition[2];
uniform vec4 u_SpotLightsColor[2];
uniform float u_SpotLightsIntensity[2];
uniform float u_SpotLightsAttenRangeInv[2];
uniform vec4 u_SpotLightsDirection[2];
uniform float u_SpotLightsOuterAngleCos[2];
uniform float u_SpotLightsInnerAngleCos[2];
uniform float _AmbientIntensity;
uniform float _AmbientRotation;
uniform vec4 _AlbedoColor;
uniform float _Metallic;
uniform float _Roughness;
uniform mediump sampler2D _AmbientTexture;

in vec3 v_posWS;
in vec3 v_nDirWS;
layout(location = 0) out vec4 glResult;

float _6659;

void main()
{
    vec3 _2204 = vec3(pow(_AlbedoColor.x, 2.2000000476837158203125), pow(_AlbedoColor.y, 2.2000000476837158203125), pow(_AlbedoColor.z, 2.2000000476837158203125));
    vec3 _2081 = normalize(v_nDirWS);
    float _2440 = clamp(_Metallic, 0.0, 1.0);
    float _2339 = clamp(_Roughness, 0.07999999821186065673828125, 1.0);
    float _2445 = _2339 * _2339;
    float _2450 = _2445 * _2445;
    vec3 _2363 = _2204 * (0.959999978542327880859375 * (1.0 - _2440));
    vec3 _2370 = mix(vec3(0.039999999105930328369140625), _2204, vec3(_2440));
    vec3 _2405 = normalize(u_WorldSpaceCameraPos.xyz - v_posWS);
    vec3 _6492;
    if (dot(_2405, _2081) < 0.0)
    {
        _6492 = reflect(_2405, _2081);
    }
    else
    {
        _6492 = _2405;
    }
    vec3 _2431 = normalize(reflect(-_6492, _2081));
    float _2473 = max(0.0, dot(_2081, _6492));
    float _2496 = min(1.0 + dot(_2431, _2081), 1.0);
    float _2502 = clamp(pow(_2473 + 1.0, exp2((-16.0) * _2339 + (-1.0))), 0.0, 1.0) * (_2496 * _2496);
    float _2566 = u_DirLightsEnabled[0] * step(0.5, u_DirLightNum);
    vec3 _2573 = normalize(-u_DirLightsDirection[0].xyz);
    float _2585 = u_DirLightsIntensity[0] * _2566;
    float _2600 = u_DirLightsEnabled[1] * step(1.5, u_DirLightNum);
    vec3 _2607 = normalize(-u_DirLightsDirection[1].xyz);
    float _2619 = u_DirLightsIntensity[1] * _2600;
    float _2634 = u_DirLightsEnabled[2] * step(2.5, u_DirLightNum);
    vec3 _2641 = normalize(-u_DirLightsDirection[2].xyz);
    float _2653 = u_DirLightsIntensity[2] * _2634;
    float _2675 = u_PointLightsEnabled[0] * step(0.5, u_PointLightNum);
    vec3 _2683 = u_PointLightsPosition[0].xyz - v_posWS;
    float _2685 = length(_2683);
    vec3 _2689 = _2683 / vec3(_2685);
    float _2701 = u_PointLightsIntensity[0] * _2675;
    float _2707 = _2685 * u_PointLightsAttenRangeInv[0];
    float _2729 = _2707 * _2707;
    float _2736 = clamp((-_2729) * _2729 + 1.0, 0.0, 1.0);
    vec3 _2721 = vec3(((_2736 * _2736) * (_2707 * _2707 + 1.0)) * 0.25);
    float _2765 = u_PointLightsEnabled[1] * step(1.5, u_PointLightNum);
    vec3 _2773 = u_PointLightsPosition[1].xyz - v_posWS;
    float _2775 = length(_2773);
    vec3 _2779 = _2773 / vec3(_2775);
    float _2791 = u_PointLightsIntensity[1] * _2765;
    float _2797 = _2775 * u_PointLightsAttenRangeInv[1];
    float _2819 = _2797 * _2797;
    float _2826 = clamp((-_2819) * _2819 + 1.0, 0.0, 1.0);
    vec3 _2811 = vec3(((_2826 * _2826) * (_2797 * _2797 + 1.0)) * 0.25);
    float _2857 = u_SpotLightsEnabled[0] * step(0.5, u_SpotLightNum);
    vec3 _2865 = u_SpotLightsPosition[0].xyz - v_posWS;
    float _2867 = length(_2865);
    vec3 _2871 = _2865 / vec3(_2867);
    float _2883 = u_SpotLightsIntensity[0] * _2857;
    float _2889 = _2867 * u_SpotLightsAttenRangeInv[0];
    float _2932 = _2889 * _2889;
    float _2939 = clamp((-_2932) * _2932 + 1.0, 0.0, 1.0);
    vec3 _2924 = vec3((((_2939 * _2939) * (_2889 * _2889 + 1.0)) * 0.25) * smoothstep(u_SpotLightsOuterAngleCos[0], u_SpotLightsInnerAngleCos[0], max(0.0, dot(_2871, normalize(-u_SpotLightsDirection[0].xyz)))));
    float _2970 = u_SpotLightsEnabled[1] * step(1.5, u_SpotLightNum);
    vec3 _2978 = u_SpotLightsPosition[1].xyz - v_posWS;
    float _2980 = length(_2978);
    vec3 _2984 = _2978 / vec3(_2980);
    float _2996 = u_SpotLightsIntensity[1] * _2970;
    float _3002 = _2980 * u_SpotLightsAttenRangeInv[1];
    float _3045 = _3002 * _3002;
    float _3052 = clamp((-_3045) * _3045 + 1.0, 0.0, 1.0);
    vec3 _3037 = vec3((((_3052 * _3052) * (_3002 * _3002 + 1.0)) * 0.25) * smoothstep(u_SpotLightsOuterAngleCos[1], u_SpotLightsInnerAngleCos[1], max(0.0, dot(_2984, normalize(-u_SpotLightsDirection[1].xyz)))));
    vec3 _3324 = normalize(_2081);
    float _3327 = -_3324.z;
    float _3329 = _3324.x;
    float _3336 = acos(_3324.y);
    float _3342 = (((_3329 < 0.0) ? (-1.0) : 1.0) * acos(clamp(_3327 / length(vec2(_3329, _3327)), -1.0, 1.0)) + (-1.57079637050628662109375)) * 0.15915493667125701904296875 + _AmbientRotation;
    float _3351 = fract((_3342 + floor(_3342)) + 1.0);
    vec2 _6251 = vec2(_6659, _3336 * 0.3183098733425140380859375);
    _6251.x = _3351;
    float _3379 = floor(7.0);
    vec2 _6499;
    vec2 _6507;
    if (abs(_3379) < 0.001000000047497451305389404296875)
    {
        _6507 = vec2((_3351 * 0.99609375 + 0.001953125) * 0.5, (_3336 * 0.315823078155517578125 + 0.00390625) * 0.25 + 0.5);
        _6499 = vec2(_3351 * 0.998046875 + 0.0009765625, (_3336 * 0.3170664608478546142578125 + 0.001953125) * 0.5);
    }
    else
    {
        vec2 _6500;
        vec2 _6508;
        if (abs(_3379 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _3432 = _3351 * 0.99609375 + 0.001953125;
            float _3442 = (_3336 * 0.315823078155517578125 + 0.00390625) * 0.25 + 0.5;
            _6508 = vec2(_3432 * 0.5 + 0.5, _3442);
            _6500 = vec2(_3432 * 0.5, _3442);
        }
        else
        {
            vec2 _6501;
            vec2 _6509;
            if (abs(_3379 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _3470 = _3351 * 0.99609375 + 0.001953125;
                float _3478 = _3336 * 0.315823078155517578125 + 0.00390625;
                _6509 = vec2(_3470 * 0.5, _3478 * 0.25 + 0.75);
                _6501 = vec2(_3470 * 0.5 + 0.5, _3478 * 0.25 + 0.5);
            }
            else
            {
                vec2 _6502;
                vec2 _6510;
                if (abs(_3379 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _6510 = vec2((_3351 * 0.9921875 + 0.00390625) * 0.25 + 0.5, (_3336 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.75);
                    _6502 = vec2((_3351 * 0.99609375 + 0.001953125) * 0.5, (_3336 * 0.315823078155517578125 + 0.00390625) * 0.25 + 0.75);
                }
                else
                {
                    vec2 _6503;
                    vec2 _6511;
                    if (abs(_3379 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _3546 = _3351 * 0.9921875 + 0.00390625;
                        float _3556 = (_3336 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.75;
                        _6511 = vec2(_3546 * 0.25 + 0.75, _3556);
                        _6503 = vec2(_3546 * 0.25 + 0.5, _3556);
                    }
                    else
                    {
                        vec2 _6504;
                        vec2 _6512;
                        if (abs(_3379 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _3584 = _3351 * 0.9921875 + 0.00390625;
                            float _3592 = _3336 * 0.3133362829685211181640625 + 0.0078125;
                            _6512 = vec2(_3584 * 0.25 + 0.5, _3592 * 0.125 + 0.875);
                            _6504 = vec2(_3584 * 0.25 + 0.75, _3592 * 0.125 + 0.75);
                        }
                        else
                        {
                            vec2 _6505;
                            vec2 _6513;
                            if (abs(_3379 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _3622 = _3351 * 0.9921875 + 0.00390625;
                                float _3632 = (_3336 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.875;
                                _6513 = vec2(_3622 * 0.25 + 0.75, _3632);
                                _6505 = vec2(_3622 * 0.25 + 0.5, _3632);
                            }
                            else
                            {
                                vec2 _6514;
                                if (abs(_3379 - 7.0) < 0.001000000047497451305389404296875)
                                {
                                    _6514 = vec2((_3351 * 0.9921875 + 0.00390625) * 0.25 + 0.75, (_3336 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.875);
                                }
                                else
                                {
                                    _6514 = _6251;
                                }
                                _6513 = _6514;
                                _6505 = _6514;
                            }
                            _6512 = _6513;
                            _6504 = _6505;
                        }
                        _6511 = _6512;
                        _6503 = _6504;
                    }
                    _6510 = _6511;
                    _6502 = _6503;
                }
                _6509 = _6510;
                _6501 = _6502;
            }
            _6508 = _6509;
            _6500 = _6501;
        }
        _6507 = _6508;
        _6499 = _6500;
    }
    mediump vec4 _3698 = texture(_AmbientTexture, _6499);
    mediump vec4 _3701 = texture(_AmbientTexture, _6507);
    vec4 _3704 = mix(_3698, _3701, vec4(7.0 - _3379));
    vec3 _3116 = ((((_3704.xyz / vec3(_3704.w)) * _2363) * max(vec3(1.0), ((((((_2363 * 2.040400028228759765625) - vec3(0.3323999941349029541015625)) * 1.0) + ((_2363 * (-4.79510021209716796875)) + vec3(0.6417000293731689453125))) * 1.0) + ((_2363 * 2.755199909210205078125) + vec3(0.69029998779296875))) * 1.0)) * _AmbientIntensity) * 1.0;
    float _3767 = _2339 - 0.07999999821186065673828125;
    vec3 _3807 = normalize(mix(_2431, _2081, vec3(_2339 * _2445)));
    float _3810 = -_3807.z;
    float _3812 = _3807.x;
    float _3819 = acos(_3807.y);
    float _3825 = (((_3812 < 0.0) ? (-1.0) : 1.0) * acos(clamp(_3810 / length(vec2(_3812, _3810)), -1.0, 1.0)) + (-1.57079637050628662109375)) * 0.15915493667125701904296875 + _AmbientRotation;
    float _3834 = fract((_3825 + floor(_3825)) + 1.0);
    vec2 _6366 = vec2(_6659, _3819 * 0.3183098733425140380859375);
    _6366.x = _3834;
    float _3862 = floor(_3767 * 7.0);
    vec2 _6532;
    vec2 _6540;
    if (abs(_3862) < 0.001000000047497451305389404296875)
    {
        _6540 = vec2((_3834 * 0.99609375 + 0.001953125) * 0.5, (_3819 * 0.315823078155517578125 + 0.00390625) * 0.25 + 0.5);
        _6532 = vec2(_3834 * 0.998046875 + 0.0009765625, (_3819 * 0.3170664608478546142578125 + 0.001953125) * 0.5);
    }
    else
    {
        vec2 _6533;
        vec2 _6541;
        if (abs(_3862 - 1.0) < 0.001000000047497451305389404296875)
        {
            float _3915 = _3834 * 0.99609375 + 0.001953125;
            float _3925 = (_3819 * 0.315823078155517578125 + 0.00390625) * 0.25 + 0.5;
            _6541 = vec2(_3915 * 0.5 + 0.5, _3925);
            _6533 = vec2(_3915 * 0.5, _3925);
        }
        else
        {
            vec2 _6534;
            vec2 _6542;
            if (abs(_3862 - 2.0) < 0.001000000047497451305389404296875)
            {
                float _3953 = _3834 * 0.99609375 + 0.001953125;
                float _3961 = _3819 * 0.315823078155517578125 + 0.00390625;
                _6542 = vec2(_3953 * 0.5, _3961 * 0.25 + 0.75);
                _6534 = vec2(_3953 * 0.5 + 0.5, _3961 * 0.25 + 0.5);
            }
            else
            {
                vec2 _6535;
                vec2 _6543;
                if (abs(_3862 - 3.0) < 0.001000000047497451305389404296875)
                {
                    _6543 = vec2((_3834 * 0.9921875 + 0.00390625) * 0.25 + 0.5, (_3819 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.75);
                    _6535 = vec2((_3834 * 0.99609375 + 0.001953125) * 0.5, (_3819 * 0.315823078155517578125 + 0.00390625) * 0.25 + 0.75);
                }
                else
                {
                    vec2 _6536;
                    vec2 _6544;
                    if (abs(_3862 - 4.0) < 0.001000000047497451305389404296875)
                    {
                        float _4029 = _3834 * 0.9921875 + 0.00390625;
                        float _4039 = (_3819 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.75;
                        _6544 = vec2(_4029 * 0.25 + 0.75, _4039);
                        _6536 = vec2(_4029 * 0.25 + 0.5, _4039);
                    }
                    else
                    {
                        vec2 _6537;
                        vec2 _6545;
                        if (abs(_3862 - 5.0) < 0.001000000047497451305389404296875)
                        {
                            float _4067 = _3834 * 0.9921875 + 0.00390625;
                            float _4075 = _3819 * 0.3133362829685211181640625 + 0.0078125;
                            _6545 = vec2(_4067 * 0.25 + 0.5, _4075 * 0.125 + 0.875);
                            _6537 = vec2(_4067 * 0.25 + 0.75, _4075 * 0.125 + 0.75);
                        }
                        else
                        {
                            vec2 _6538;
                            vec2 _6546;
                            if (abs(_3862 - 6.0) < 0.001000000047497451305389404296875)
                            {
                                float _4105 = _3834 * 0.9921875 + 0.00390625;
                                float _4115 = (_3819 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.875;
                                _6546 = vec2(_4105 * 0.25 + 0.75, _4115);
                                _6538 = vec2(_4105 * 0.25 + 0.5, _4115);
                            }
                            else
                            {
                                vec2 _6547;
                                if (abs(_3862 - 7.0) < 0.001000000047497451305389404296875)
                                {
                                    _6547 = vec2((_3834 * 0.9921875 + 0.00390625) * 0.25 + 0.75, (_3819 * 0.3133362829685211181640625 + 0.0078125) * 0.125 + 0.875);
                                }
                                else
                                {
                                    _6547 = _6366;
                                }
                                _6546 = _6547;
                                _6538 = _6547;
                            }
                            _6545 = _6546;
                            _6537 = _6538;
                        }
                        _6544 = _6545;
                        _6536 = _6537;
                    }
                    _6543 = _6544;
                    _6535 = _6536;
                }
                _6542 = _6543;
                _6534 = _6535;
            }
            _6541 = _6542;
            _6533 = _6534;
        }
        _6540 = _6541;
        _6532 = _6533;
    }
    vec4 _4187 = mix(texture(_AmbientTexture, _6532), texture(_AmbientTexture, _6540), vec4(_3767 * 7.0 + (-_3862)));
    vec4 _4212 = (vec4(-1.0, -0.0274999998509883880615234375, -0.572000026702880859375, 0.02199999988079071044921875) * _2339) + vec4(1.0, 0.0425000004470348358154296875, 1.03999996185302734375, -0.039999999105930328369140625);
    float _4214 = _4212.x;
    vec2 _4232 = (vec2(-1.03999996185302734375, 1.03999996185302734375) * (min(_4214 * _4214, exp2((-9.27999973297119140625) * _2473)) * _4214 + _4212.y)) + _4212.zw;
    vec3 _3123 = (((((_2370 * _4232.x) + vec3(_4232.y * clamp(50.0 * _2370.y, 0.0, 1.0))) * (_4187.xyz / vec3(_4187.w))) * max(vec3(_2502), ((((((_2370 * 2.040400028228759765625) - vec3(0.3323999941349029541015625)) * _2502) + ((_2370 * (-4.79510021209716796875)) + vec3(0.6417000293731689453125))) * _2502) + ((_2370 * 2.755199909210205078125) + vec3(0.69029998779296875))) * _2502)) * _AmbientIntensity) * 1.0;
    vec3 _6575;
    vec3 _6576;
    if (_2566 > 0.5)
    {
        vec3 _4305 = normalize(_2573 + _6492);
        float _4311 = max(0.0, dot(_2081, _2573));
        float _4322 = max(0.0, dot(_6492, _4305));
        float _4338 = (-_2473) * _4311 + ((2.0 * _4322) * _4322 + (-1.0));
        float _6564;
        if (_4338 >= 0.0)
        {
            _6564 = 1.0 / max(_4311, _2473);
        }
        else
        {
            _6564 = 1.0;
        }
        float _4416 = max(0.0, dot(_2081, _4305));
        float _4474 = 1.0 - _4311;
        float _4502 = (_4416 * _2450 + (-_4416)) * _4416 + 1.0;
        float _4515 = 1.0 - _4322;
        float _4529 = _4515 * _4515;
        _6576 = _3123 + ((((((((_2370 + ((vec3(1.0) - _2370) * ((_4529 * _4529) * _4515))) * (0.5 / ((_2445 * (_2473 * _4474 + _4311) + (_2473 * (_2445 * _4474 + _4311))) + 9.9999997473787516355514526367188e-06))) * ((_2450 * 0.31830990314483642578125) / (_4502 * _4502 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4311) * u_DirLightsColor[0].xyz) * _2585) * 1.0);
        _6575 = _3116 + ((((_2363 * u_DirLightsColor[0].xyz) * _2585) * ((((((0.449999988079071044921875 * _2450) / (_2445 * _2445 + 0.0900000035762786865234375)) * _4338) * _6564 + (1.0 - ((0.5 * _2450) / (_2445 * _2445 + 0.3300000131130218505859375)))) * (_2339 * 0.5 + 1.0)) * _4311)) * 1.0);
    }
    else
    {
        _6576 = _3123;
        _6575 = _3116;
    }
    vec3 _6577;
    vec3 _6578;
    if (_2600 > 0.5)
    {
        float _4544 = max(0.0, dot(_2081, _2607));
        vec3 _4580 = normalize(_2607 + _6492);
        float _4585 = max(0.0, dot(_2081, _4580));
        float _4639 = (_4585 * _2450 + (-_4585)) * _4585 + 1.0;
        float _4652 = 1.0 - max(0.0, dot(_6492, _4580));
        float _4666 = _4652 * _4652;
        _6578 = _6576 + ((((((((_2370 + ((vec3(1.0) - _2370) * ((_4666 * _4666) * _4652))) * 0.25) * ((_2450 * 0.31830990314483642578125) / (_4639 * _4639 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4544) * u_DirLightsColor[1].xyz) * _2619) * 1.0);
        _6577 = _6575 + ((((_2363 * u_DirLightsColor[1].xyz) * _2619) * _4544) * 1.0);
    }
    else
    {
        _6578 = _6576;
        _6577 = _6575;
    }
    vec3 _6579;
    vec3 _6580;
    if (_2634 > 0.5)
    {
        float _4681 = max(0.0, dot(_2081, _2641));
        vec3 _4717 = normalize(_2641 + _6492);
        float _4722 = max(0.0, dot(_2081, _4717));
        float _4776 = (_4722 * _2450 + (-_4722)) * _4722 + 1.0;
        float _4789 = 1.0 - max(0.0, dot(_6492, _4717));
        float _4803 = _4789 * _4789;
        _6580 = _6578 + ((((((((_2370 + ((vec3(1.0) - _2370) * ((_4803 * _4803) * _4789))) * 0.25) * ((_2450 * 0.31830990314483642578125) / (_4776 * _4776 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4681) * u_DirLightsColor[2].xyz) * _2653) * 1.0);
        _6579 = _6577 + ((((_2363 * u_DirLightsColor[2].xyz) * _2653) * _4681) * 1.0);
    }
    else
    {
        _6580 = _6578;
        _6579 = _6577;
    }
    vec3 _6581;
    vec3 _6582;
    if (_2675 > 0.5)
    {
        float _4818 = max(0.0, dot(_2081, _2689));
        vec3 _4854 = normalize(_2689 + _6492);
        float _4859 = max(0.0, dot(_2081, _4854));
        float _4913 = (_4859 * _2450 + (-_4859)) * _4859 + 1.0;
        float _4926 = 1.0 - max(0.0, dot(_6492, _4854));
        float _4940 = _4926 * _4926;
        _6582 = _6580 + (((((((((_2370 + ((vec3(1.0) - _2370) * ((_4940 * _4940) * _4926))) * 0.25) * ((_2450 * 0.31830990314483642578125) / (_4913 * _4913 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4818) * u_PointLightsColor[0].xyz) * _2701) * _2721) * 1.0);
        _6581 = _6579 + (((((_2363 * u_PointLightsColor[0].xyz) * _2701) * _2721) * _4818) * 1.0);
    }
    else
    {
        _6582 = _6580;
        _6581 = _6579;
    }
    vec3 _6583;
    vec3 _6584;
    if (_2765 > 0.5)
    {
        float _4955 = max(0.0, dot(_2081, _2779));
        vec3 _4991 = normalize(_2779 + _6492);
        float _4996 = max(0.0, dot(_2081, _4991));
        float _5050 = (_4996 * _2450 + (-_4996)) * _4996 + 1.0;
        float _5063 = 1.0 - max(0.0, dot(_6492, _4991));
        float _5077 = _5063 * _5063;
        _6584 = _6582 + (((((((((_2370 + ((vec3(1.0) - _2370) * ((_5077 * _5077) * _5063))) * 0.25) * ((_2450 * 0.31830990314483642578125) / (_5050 * _5050 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _4955) * u_PointLightsColor[1].xyz) * _2791) * _2811) * 1.0);
        _6583 = _6581 + (((((_2363 * u_PointLightsColor[1].xyz) * _2791) * _2811) * _4955) * 1.0);
    }
    else
    {
        _6584 = _6582;
        _6583 = _6581;
    }
    vec3 _6585;
    vec3 _6586;
    if (_2857 > 0.5)
    {
        float _5092 = max(0.0, dot(_2081, _2871));
        vec3 _5128 = normalize(_2871 + _6492);
        float _5133 = max(0.0, dot(_2081, _5128));
        float _5187 = (_5133 * _2450 + (-_5133)) * _5133 + 1.0;
        float _5200 = 1.0 - max(0.0, dot(_6492, _5128));
        float _5214 = _5200 * _5200;
        _6586 = _6584 + (((((((((_2370 + ((vec3(1.0) - _2370) * ((_5214 * _5214) * _5200))) * 0.25) * ((_2450 * 0.31830990314483642578125) / (_5187 * _5187 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _5092) * u_SpotLightsColor[0].xyz) * _2883) * _2924) * 1.0);
        _6585 = _6583 + (((((_2363 * u_SpotLightsColor[0].xyz) * _2883) * _2924) * _5092) * 1.0);
    }
    else
    {
        _6586 = _6584;
        _6585 = _6583;
    }
    vec3 _6587;
    vec3 _6588;
    if (_2970 > 0.5)
    {
        float _5229 = max(0.0, dot(_2081, _2984));
        vec3 _5265 = normalize(_2984 + _6492);
        float _5270 = max(0.0, dot(_2081, _5265));
        float _5324 = (_5270 * _2450 + (-_5270)) * _5270 + 1.0;
        float _5337 = 1.0 - max(0.0, dot(_6492, _5265));
        float _5351 = _5337 * _5337;
        _6588 = _6586 + (((((((((_2370 + ((vec3(1.0) - _2370) * ((_5351 * _5351) * _5337))) * 0.25) * ((_2450 * 0.31830990314483642578125) / (_5324 * _5324 + 1.0000000116860974230803549289703e-07))) * 3.1415927410125732421875) * _5229) * u_SpotLightsColor[1].xyz) * _2996) * _3037) * 1.0);
        _6587 = _6585 + (((((_2363 * u_SpotLightsColor[1].xyz) * _2996) * _3037) * _5229) * 1.0);
    }
    else
    {
        _6588 = _6586;
        _6587 = _6585;
    }
    vec3 _3275 = _6587 + _6588;
    glResult = vec4(pow(_3275.x, 0.4545449912548065185546875), pow(_3275.y, 0.4545449912548065185546875), pow(_3275.z, 0.4545449912548065185546875), _AlbedoColor.w);
}

