#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    spvUnsafeArray<float4, 3> u_DirLightsDirection;
    spvUnsafeArray<float4, 3> u_DirLightsColor;
    spvUnsafeArray<float, 3> u_DirLightsIntensity;
    spvUnsafeArray<float, 3> u_DirLightsEnabled;
    spvUnsafeArray<float4, 2> u_PointLightsPosition;
    spvUnsafeArray<float4, 2> u_PointLightsColor;
    spvUnsafeArray<float, 2> u_PointLightsIntensity;
    spvUnsafeArray<float, 2> u_PointLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_PointLightsEnabled;
    spvUnsafeArray<float4, 2> u_SpotLightsDirection;
    spvUnsafeArray<float4, 2> u_SpotLightsPosition;
    spvUnsafeArray<float4, 2> u_SpotLightsColor;
    spvUnsafeArray<float, 2> u_SpotLightsIntensity;
    spvUnsafeArray<float, 2> u_SpotLightsInnerAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsOuterAngleCos;
    spvUnsafeArray<float, 2> u_SpotLightsAttenRangeInv;
    spvUnsafeArray<float, 2> u_SpotLightsEnabled;
    float4 u_AlbedoColor;
};

struct main0_out
{
    float4 o_fragColor [[color(0)]];
};

struct main0_in
{
    float3 g_vary_WorldPosition [[user(locn1)]];
    float3 g_vary_WorldNormal [[user(locn2)]];
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    float3 _717 = fast::normalize(in.g_vary_WorldNormal);
    bool _1006 = buffer.u_DirLightsEnabled[0] > 0.5;
    float3 _2657;
    if (_1006)
    {
        _2657 = (((buffer.u_AlbedoColor.xyz * fma(dot(_717, fast::normalize(-buffer.u_DirLightsDirection[0].xyz)), 0.5, 0.5)) * buffer.u_DirLightsIntensity[0]) * buffer.u_DirLightsColor[0].xyz) * buffer.u_DirLightsEnabled[0];
    }
    else
    {
        _2657 = float3(0.0);
    }
    bool _1027 = buffer.u_DirLightsEnabled[1] > 0.5;
    float3 _2658;
    if (_1027)
    {
        _2658 = _2657 + ((((buffer.u_AlbedoColor.xyz * fma(dot(_717, fast::max(fast::normalize(-buffer.u_DirLightsDirection[1].xyz), float3(0.001000000047497451305389404296875))), 0.5, 0.5)) * buffer.u_DirLightsIntensity[1]) * buffer.u_DirLightsColor[1].xyz) * buffer.u_DirLightsEnabled[1]);
    }
    else
    {
        _2658 = _2657;
    }
    float3 _2661;
    if (_1006)
    {
        float3 _1171 = (buffer.u_PointLightsPosition[0].xyz - in.g_vary_WorldPosition) * buffer.u_PointLightsAttenRangeInv[0];
        float _1173 = length(_1171);
        float _1184 = dot(_717, _1171 / float3(fast::max(_1173, 0.001000000047497451305389404296875)));
        _2661 = ((((buffer.u_AlbedoColor.xyz * fma(_1184, 0.5, 0.5)) * buffer.u_PointLightsIntensity[0]) * buffer.u_PointLightsColor[0].xyz) * (((pow(fast::clamp(1.0 - pow(_1173, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1173, 2.0) + 1.0)) * fast::max(0.0, _1184))) * buffer.u_PointLightsEnabled[0];
    }
    else
    {
        _2661 = float3(0.0);
    }
    float3 _2662;
    if (_1027)
    {
        float3 _1227 = (buffer.u_PointLightsPosition[1].xyz - in.g_vary_WorldPosition) * buffer.u_PointLightsAttenRangeInv[1];
        float _1229 = length(_1227);
        float _1240 = dot(_717, _1227 / float3(fast::max(_1229, 0.001000000047497451305389404296875)));
        _2662 = _2661 + (((((buffer.u_AlbedoColor.xyz * fma(_1240, 0.5, 0.5)) * buffer.u_PointLightsIntensity[1]) * buffer.u_PointLightsColor[1].xyz) * (((pow(fast::clamp(1.0 - pow(_1229, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1229, 2.0) + 1.0)) * fast::max(0.0, _1240))) * buffer.u_PointLightsEnabled[1]);
    }
    else
    {
        _2662 = _2661;
    }
    float3 _2665;
    if (_1006)
    {
        float3 _1397 = (buffer.u_SpotLightsPosition[0].xyz - in.g_vary_WorldPosition) * buffer.u_SpotLightsAttenRangeInv[0];
        float _1399 = length(_1397);
        float3 _1404 = _1397 / float3(fast::max(_1399, 0.00999999977648258209228515625));
        float _1410 = dot(_717, _1404);
        _2665 = ((((buffer.u_AlbedoColor.xyz * fma(_1410, 0.5, 0.5)) * buffer.u_SpotLightsIntensity[0]) * buffer.u_SpotLightsColor[0].xyz) * ((((pow(fast::clamp(1.0 - pow(_1399, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1399, 2.0) + 1.0)) * fast::max(0.0, _1410)) * smoothstep(buffer.u_SpotLightsOuterAngleCos[0], buffer.u_SpotLightsInnerAngleCos[0], fast::max(0.0, dot(_1404, fast::normalize(-buffer.u_SpotLightsDirection[0].xyz)))))) * buffer.u_SpotLightsEnabled[0];
    }
    else
    {
        _2665 = float3(0.0);
    }
    float3 _2666;
    if (_1027)
    {
        float3 _1467 = (buffer.u_SpotLightsPosition[1].xyz - in.g_vary_WorldPosition) * buffer.u_SpotLightsAttenRangeInv[1];
        float _1469 = length(_1467);
        float3 _1474 = _1467 / float3(fast::max(_1469, 0.00999999977648258209228515625));
        float _1480 = dot(_717, _1474);
        _2666 = _2665 + (((((buffer.u_AlbedoColor.xyz * fma(_1480, 0.5, 0.5)) * buffer.u_SpotLightsIntensity[1]) * buffer.u_SpotLightsColor[1].xyz) * ((((pow(fast::clamp(1.0 - pow(_1469, 4.0), 0.0, 1.0), 2.0) * 0.25) * (pow(_1469, 2.0) + 1.0)) * fast::max(0.0, _1480)) * smoothstep(buffer.u_SpotLightsOuterAngleCos[1], buffer.u_SpotLightsInnerAngleCos[1], fast::max(0.0, dot(_1474, fast::normalize(-buffer.u_SpotLightsDirection[1].xyz)))))) * buffer.u_SpotLightsEnabled[1]);
    }
    else
    {
        _2666 = _2665;
    }
    out.o_fragColor = float4(pow((_2658 + _2662) + _2666, float3(0.454545438289642333984375)), buffer.u_AlbedoColor.w);
    return out;
}

